package net.minecraft.src.pwnedgod.InductionFix;

import net.minecraft.src.TileEntity;
import net.minecraft.src.ic2.api.EnergyNet;
import net.minecraft.src.ic2.common.PositionSpec;
import net.minecraft.src.ic2.common.TileEntityInduction;
import net.minecraft.src.ic2.platform.AudioManager;
import net.minecraft.src.ic2.platform.AudioSource;
import net.minecraft.src.ic2.platform.Platform;

public class TileEntityInductionFix extends TileEntityInduction
{
	public TileEntityInductionFix()
	{
		super();
	}
	
	public void invalidate()
	{
		if(Platform.isRendering() && audioSource != null)
        {
            AudioManager.removeSources(this);
            audioSource = null;
        }
        super.invalidate();
	}
	
	public void updateEntity()
    {
		//////////////////////////////////////////////////////////////
		//This is just a bunch of unnecessary code because			//
		//i don't want this to call the updateEntity in 			//
		//TileEntityInduction										//
		//the lines covered by the '//' must be replaced by			//
		//super.updateEntity() if you want this to be originally on //
		//TileEntityInduction										//
		//////////////////////////////////////////////////////////////
		//super.updateEntity()										//
		//Taken from TileEntityBlock								//
		if(!created)												//
		{															//
			onCreated();											//
			created = true;											//
		}															//
		//Taken from TileEntityElecMachine							//
		//super.updateEntity()										//
		if(Platform.isSimulating() && !addedToEnergyNet)			//
        {															//
            EnergyNet.getForWorld(worldObj).addTileEntity(this);	//
            addedToEnergyNet = true;								//
        }															//
		//////////////////////////////////////////////////////////////
		if(Platform.isSimulating())
        {
            boolean needsInvUpdate = false;
            if(energy <= maxEnergy)
                needsInvUpdate = provideEnergy();
            boolean newActive = getActive();
            if (heat == 0)
            {
            	newActive = false; //To fix the active state bug
            }
            if(progress >= 4000)
            {
                operate();
                needsInvUpdate = true;
                progress = 0;
                newActive = false;
            }
            boolean canOperate = canOperate();
            if(energy > 0 && (canOperate || isRedstonePowered()))
            {
                energy--;
                if(heat < maxHeat)
                    heat++;
                newActive = true;
            } else
            {
                heat -= Math.min(heat, 4);
            }
            if(!newActive || progress == 0)
            {
                if(canOperate)
                {
                    if(energy >= 15)
                        newActive = true;
                } else
                {
                    progress = 0;
                }
            } else if(!canOperate || energy < 15)
            {
                if(!canOperate)
                    progress = 0;
                newActive = false;
            }
            if(newActive && canOperate)
            {
                progress += heat / 30;
                energy -= 15;
            }
            if(needsInvUpdate)
            	onInventoryChanged();
            if(newActive != getActive())
            {
                setActive(newActive);
                if(!newActive)
                {
                	if(audioSource != null)
                	{
                		audioSource.stop();
                		AudioManager.playOnce(this, getStopSoundFile());
                	}
                }
                if(newActive)
                {
                	if(audioSource != null)
                	{
                		AudioManager.playOnce(this, getStartSoundFile());
                	}
                }
                worldObj.markBlockNeedsUpdate(xCoord, yCoord, zCoord); //(very)Necessary for Textures to Update correctly and Moved down for better update (Feb 29 2012)
            }
        }
    }
	
	public String getOperationSoundFile()
    {
        return "Machines/Induction Furnace/InductionLoop.ogg";
    }
	
	public String getStopSoundFile()
    {
        return "Machines/Induction Furnace/InductionStop.ogg";
    }
	
	public String getStartSoundFile()
    {
        return "Machines/Induction Furnace/InductionStart.ogg";
    }
	
	public void onNetworkUpdate(String field)
    {
        if(field.equals("active") && prevActive != getActive())
        {
            if(audioSource == null && getOperationSoundFile() != null)
            	audioSource = AudioManager.createSource(this, PositionSpec.Center, getOperationSoundFile(), true, false, AudioManager.defaultVolume);
            if(getActive())
            {
            	if(audioSource != null)
            		audioSource.play();
            } else
            if(audioSource != null)
            	audioSource.stop();
        }
        super.onNetworkUpdate(field);
    }
	
	public AudioSource audioSource;
}
